
	.586
	.model flat,stdcall
	option casemap:none
	
	include windows.inc
	include kernel32.inc
	include user32.inc
	include gdi32.inc
	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
	
	PaintText PROTO :DWORD
	
	.data
	ClassName db "Application",0
	hInstance HINSTANCE 0
	FaceName db "Arial",0
	String1 db "TextOutExample",0
	hMenu HMENU 0
	
	.code
	
WinMain PROC hInst:DWORD,hPrev:DWORD,lpCmd:DWORD,nShow:DWORD

		LOCAL wc:WNDCLASSEX
		LOCAL msg:MSG
		LOCAL hwnd:HWND
		
			invoke GetModuleHandle,NULL
			mov hInstance,eax
			
			mov wc.cbClsExtra,NULL
			mov wc.cbSize,sizeof wc
			mov wc.cbWndExtra,NULL
			mov wc.hbrBackground,COLOR_WINDOW-1
			invoke LoadCursor,NULL,IDC_ARROW
			mov wc.hCursor,eax
			invoke LoadIcon,hInstance,IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,eax
			push hInstance
			pop wc.hInstance
			mov wc.lpfnWndProc,offset WndProc
			mov wc.lpszClassName,offset ClassName
			mov wc.lpszMenuName,NULL
			mov wc.style,CS_HREDRAW or CS_VREDRAW
			
			invoke RegisterClassEx,addr wc
			invoke CreateWindowEx,NULL,addr ClassName,addr ClassName,
						WS_OVERLAPPEDWINDOW,400,300,200,150,0,0,hInstance,0
			mov hwnd,eax
			invoke ShowWindow,hwnd,SW_SHOWNORMAL
			invoke UpdateWindow,eax
			
			.while TRUE
				
				invoke GetMessage,addr msg,0,0,0
				.break .if(!eax)
				invoke TranslateMessage,addr msg
				invoke DispatchMessage,addr msg
				
			.endw
			
		mov eax,msg.wParam

	ret
WinMain ENDP


WndProc PROC hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
		
			.if uMsg == WM_CLOSE
				
				invoke DestroyWindow,hwnd
				invoke PostQuitMessage,NULL
				
				
			.elseif uMsg == WM_CREATE
				
				invoke LoadMenu,hInstance,500
				mov hMenu,eax
				invoke SetMenu,hwnd,eax
				invoke SetWindowPos,hwnd,HWND_TOPMOST,400,300,0,0,SWP_NOMOVE  or SWP_NOSIZE 
			.elseif uMsg == WM_PAINT
				
				
				invoke PaintText,hwnd
				
			
			.elseif uMsg == WM_KILLFOCUS
				invoke PaintText,hwnd	
				
			.elseif uMsg == WM_SETFOCUS
				invoke PaintText,hwnd
				
			.endif
	
	
	invoke DefWindowProc,hwnd,uMsg,wParam,lParam
	ret
WndProc ENDP

PaintText PROC  hwnd:DWORD
		
		LOCAL ps :PAINTSTRUCT
		LOCAL hdc :HDC
		LOCAL hFont :HFONT
		LOCAL hObj :DWORD
		LOCAL rc :RECT
		
				
				invoke GetWindowDC,hwnd
				mov hdc,eax
				invoke SetBkMode,hdc,TRANSPARENT
				invoke SetTextColor,hdc,Red
				invoke CreateFont,14,0,0,0,FW_BOLD,0,0,0,
					ANSI_CHARSET,OUT_DEFAULT_PRECIS,
					CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, 18,ADDR FaceName
				mov hFont,eax
				invoke SelectObject,hdc,hFont
				mov hObj,eax
				invoke TextOut,hdc,50,25,addr String1,sizeof String1-1
				invoke GetWindowDC,hMenu
				invoke SaveDC,eax
				invoke DeleteObject,hObj
				invoke ReleaseDC,hwnd,hdc
				
	ret
PaintText ENDP
END WinMain












